/*
  DLL template

  Author: ColDev

  License: free for all
*/

#include "stdio.h"

#include <bgddl.h>
#include "dlvaracc.h"




//---------------------------------------------------
//FUNCIONES PPALES
//---------------------------------------------------
#ifdef _arch_dreamcast
extern int configtovmu(char *src, void *bennudata,  int bennusize);
extern int configfromvmu(char *dst,   void *bennudata,  int bennusize);

extern int play_s3m(char *fn);
extern void play_s3mstop();

extern int playvideoroq(const char *nombre,int loop);
#endif






// funciones a exportar
 //-----------------------------------------------------------------------


static int fx_dc_vmuload (INSTANCE * my, int * params)
{
    const char *cadena1 =(const char *) string_get(params[0]) ; //capture string1 in params

    int res=1;

#ifdef _arch_dreamcast
     res= configfromvmu(cadena1,(void *)params[1], params[2]);
#endif

	string_discard (params[0]) ;

	return res ;
}



static int fx_dc_vmusave (INSTANCE * my, int * params)
{
    const char *cadena1 =(const char *) string_get(params[0]) ; //capture string1 in params
    int res=1;

#ifdef _arch_dreamcast
     res= configtovmu(cadena1,(void *)params[1], params[2]);
#endif

	string_discard (params[0]) ;

	return res ;
}




static int fx_dc_plays3m (INSTANCE * my, int * params)
{
    const char *cadena1 =(const char *) string_get(params[0]) ; //capture string1 in params
    int res=1;

#ifdef _arch_dreamcast
     res= play_s3m(cadena1);
#endif

	string_discard (params[0]) ;

	return res ;
}



static int fx_dc_stops3m (INSTANCE * my, int * params)
{
#ifdef _arch_dreamcast
   play_s3mstop();
#endif

	return 1 ;
}





static int fx_playvideoroq (INSTANCE * my, int * params)
{
    const char *cadena1 =(const char *) string_get(params[0]) ; //capture string1 in params
    int res=1;

#ifdef _arch_dreamcast
    res= playvideoroq(cadena1,params[1] );
#endif

	string_discard (params[0]) ;

	return res ;
}


/* ----------------------------------------------------------------- */
/* Declaracion de funciones                                          */

#define FENIX_export(a,b,c,d)  {a,b,c,(void*)d}


DLLEXPORT DLSYSFUNCS  __bgdexport(mod_dream,functions_exports)[] = {
    //initialize
	FENIX_export ("DC_VMULOAD", "SPI", TYPE_DWORD, fx_dc_vmuload ),
	FENIX_export ("DC_VMUSAVE", "SPI", TYPE_DWORD, fx_dc_vmusave ),
	FENIX_export ("DC_S3MPLAY", "S", TYPE_DWORD, fx_dc_plays3m ),
	FENIX_export ("DC_S3MSTOP", "", TYPE_DWORD, fx_dc_stops3m ),
	FENIX_export ("DC_PLAYROQ", "SI", TYPE_DWORD, fx_playvideoroq ),


	{ 0            , 0     , 0         , 0              }
};



/* ----------------------------------------------------------------- */



DLLEXPORT char * __bgdexport(mod_dream,modules_dependency)[] = {
	"mod_string",
	NULL
};
