#include <kos.h>

// VMU source code from SDL-wolf3d to Dreamcast


int configtovmu(char *src, void *bennudata,  int bennusize)
{
  char dst[32];
  file_t fd;
  int file_size=0;
  //unsigned int bzip_size;
  uint8 *data; /* Buffer for the source file.*/

  vmu_pkg_t pkg; /* VMU file header.*/
  uint8 *pkg_out; /* Buffer for the destination file.*/
  int pkg_size; /* Size of the whole vmu package. */
  ssize_t is_error; /* Make sure the file got written. */

  strcpy(dst, "/vmu/a1/");
  strcat(dst, src);   /* The name of our destination file. */

   file_size=  bennusize; /* Size of the source file. */
  // data= bennudata;

/* Write the file to the VMU. */

   strcpy(pkg.desc_short, "Bennugd save"); /* Short description of the file */
   strcpy(pkg.desc_long,  "Bennugd.org save file");//GAMENAME); /* Long description of the file */
   strcpy(pkg.app_id,     "Bennugd");/* ID of the Application creating the save */

   pkg.icon_cnt = 0; /* 1; Number of icons.  Should we make one? */
   pkg.icon_anim_speed = 0; /* We won't have animated icons. */

   pkg.eyecatch_type = VMUPKG_EC_NONE; /* We don't need an eyecatch. */
   pkg.data_len = file_size;/*bzip_size*/; /* How big the file is after the header, etc. */
   pkg.data = bennudata;/*bzipdata;*/ /* The goods. */

   vmu_pkg_build(&pkg, &pkg_out, &pkg_size);

   fs_unlink(dst);
   fd=fs_open(dst, O_WRONLY); /* Open the new VMU file. */
   is_error = fs_write(fd, pkg_out, pkg_size); /* Write the file out. */
   fs_close(fd);

   free(pkg_out); /* Delete the data we don't need anymore. */
   //free(data);

   if (is_error==-1){ return -1;} /* Reurn -1 on error */
   //if (is_error != pkg_size){ return -1;} /* Reurn -1 on error */
   //fs_unlink (src);
  return 0; /*If all went well, return 0 */
}



/*
  Given the filename of *dst, open /vmu/a1 and look for a file with that name.
  If it exists, decompress it and stick it in the current working directory
  (should be /ram).

*/

int configfromvmu(char *dst,   void *bennudata,  int bennusize)
{
  int fd1, fd2;
  vmu_pkg_t pkg;
  char src[32];
  uint8* data;
  int file_size;

  strcpy(src, "/vmu/a1/");  /* We can figure out src by the name of dst */
  strcat(src, dst);

  fd1 = fs_open(src, O_RDONLY);
  if (fd1==0){
     return -1; /* Return -1 on error. */
  }
  file_size = fs_total(fd1);
   if(file_size<=0){ return -1;}
  data = malloc(file_size);
  fs_read(fd1, data, file_size); /* Read in the VMU save */

  vmu_pkg_parse(data, &pkg);

  fs_close(fd1);

  memcpy(bennudata, pkg.data, bennusize); //copy to bennu


  free(data);

  return 0;
}
